/* ==================================================================== */
/* AUTHOR	: Firma USH	(c)  					*/
/* DATE		: 18.09.1989						*/
/* TITEL	: LOGIN procedure for BTX				*/
/* UPDATE	:							*/
/* ==================================================================== */

#include <stdio.h>
#include <termio.h>
#include <signal.h>

#include "status.h"
#include "btx.h"

int
btx_macro( number )
int	number;
{	
	FILE	*fopen();
	static 	int	count=0;
	int	send_string();
	int	btx_send(), i_exit();
	void	send_prot();
	int	btx_locate();
	void 	release_port();
		
	char	buffer[80];
	char	log[10];
	char	com[80];

	int	z, found=0;

	if(strcmp(btx_MFILE,"NONE")==0)	return(0);	/* nothing to do */

	if(logmf == (FILE *)NULL){
		if(( logmf = (FILE *)fopen( btx_MFILE, "r")) == (FILE *)NULL){
			fprintf(stderr,"Can't open Macrofile [%s]\n",btx_MFILE);
		 	release_port(1);
			i_exit( -1 );	/* signal(SIGCLD, btx_end) pcomm */	
		}
	}
	
	count++;
	while(fgets( buffer, 80 , logmf )){

		found=0;
		for(z=0; z < 3 ; z++){
			log[z]=buffer[z];
			log[z+1]='\0';
		}
		for(z=4; z < 80; z++){
			com[z-4]=buffer[z];
			com[z-3]='\0';
			if(buffer[z] <= ' ')	continue;
		}

		if(DEBUG)	fprintf(flink,"<MACRO[%s : %s]>", log, com);
		
		if(strncmp(log, "ON",2)==0){	/* turn lofile on	*/
			btx_L_MACRO=ON;
			if(DEBUG) fprintf(flink,"<MACRO [ON]>");
			found++;
		}
		if(strcmp(log, "OFF")==0){	/* turn logfile off	*/
			btx_L_MACRO=OFF;
			if(DEBUG) fprintf(flink,"<MACRO [OFF]>");
			found++;
		}
		if(strcmp(log, "LI0")==0){	/* log link.log off	*/
			DEBUG=OFF;
			PROT=OFF;
			continue;
		}
		if(strcmp(log, "LI1")==0){	/* log link.log on	*/
			DEBUG=ON;
			PROT=ON;
			continue;
		}
		if(strcmp(log, "END")==0){	/* macro and program end */
			if(DEBUG) fprintf(flink,"<MACRO [END]>\n");
			fclose( logmf );
			i_exit( -1 );
		}
		if(strcmp(log, "BEZ")==0){	/* komment 		*/
			continue;
		}
		if(strcmp(log, "WIN")==0){	/* define log-window	*/
			btx_XS = (com[0]-48) * 10 + (com[1]-48);
			btx_XE = (com[2]-48) * 10 + (com[3]-48);
			btx_YS = (com[4]-48) * 10 + (com[5]-48);
			btx_YE = (com[6]-48) * 10 + (com[7]-48);
			if(DEBUG) fprintf(flink,
				"<WIN xs[%d]xe[%d]ys[%d]ye[%d]>",
				btx_XS, btx_XE, btx_YS, btx_YE);

			if(btx_XS < 0 || btx_XS > 25)	btx_XS=0;
			if(btx_XE < 0 || btx_XE > 25) 	btx_XE=25;
			if(btx_YS < 0 || btx_YS > 80)	btx_YS=0;
			if(btx_YE < 0 || btx_YE > 80)	btx_YE=80;

			continue;
		}
		
		if(found){	/* send macro command		*/
			for(z=0; z < strlen(com);z++){
				if(com[z] > 0x19) send_prot(btx_send(com[z]));
			}
		}
		
		return(1);	/* macro is send to Vst.	*/

	}			/* read next macro command	*/

	fclose ( logmf );
	return(-1);
}

int
i_exit( parm )
int	parm;
{
	if( logfp != (FILE *)NULL) fclose( logfp );	/* close logfile    */
	if( logmf != (FILE *)NULL) fclose( logmf );	/* close macro-file */
	if( flink != (FILE *)NULL) fclose( flink );	/* close test-file  */
	if( logtw != (FILE *)NULL) fclose( logtw );	/* close TSW-file   */

	exit( parm );
}

/*
 * Release the port.  Closes the file descriptor and removes the
 * lock file
*/

void
release_port(verbose)
int verbose;
{

	/*
	 * The modem structure can't be guaranteed to exist yet.  For example,
	 * an error in reading one of the other support files would cause
	 * this routine to be used before the MODEM structure gets allocated.
	 */
					/* close the port */
	if (status->fd != -1) {
		send_string("+++");
		sleep(1);
		send_string("ATH0\r");

		ioctl(status->fd, TCFLSH, 2);
		/*
		 * Since HUPCL is set, the close() should drop the DTR and
		 * hang up the modem (provided you've got the modem to
		 * respond to DTR).  Since this is not guaranteed, we send
		 * the hang_up string first.
		 */
		close(status->fd);
		/*
		kill(0, SIGHUP);
		*/
	}
  					/* remove the lock */
	return;
}
