/* ==================================================================== */
/* AUTHOR	: Firma USH	(c)  					*/
/* DATE		: 18.09.1989						*/
/* TITEL	: Datenfluss Kontrolle CEPT Schicht 2			*/
/*		  DATA-LINK-PROTOKOLL					*/
/* UPDATE	:							*/
/* ==================================================================== */

#include <stdio.h>
#include <signal.h>
#include <curses.h>

#include "btx.h"

#define		MAX_NAK 6		/* maximum protokoll error	*/

unsigned	char  CRC_BUF[2048];
unsigned	short BLEN;

int	btx_prot( c )
unsigned char	c;
{	
	static	int	lc1;

	int	s1,s2,s3,s4,s5,s6,s7;
	int	c1;
	void 	send_prot();
	int  	readbyte(), readbcc(), i_exit();
	char	TWFILE[60];

	int	con=0;
	int	ende=1;
					/* set the trap for the signals */

	c1 = c;	
	CRC_BUF[BLEN++]=c;		/* buffer for CRC-16 check	*/
	while(ende){
		ende=0;				/* do until		*/ 

		if( (btx_TRD) && (c1 != DLE && c1 !=NAK) ){
			if(PROT) fprintf(flink, "[%x]", c1);
			if(c1 == EOT && lc1 == ETX){
				btx_TRD=OFF;
				btx_locate( 2,45 );
				addstr("End of Transmission");
				btx_locate( btx_X, btx_Y );
			}		
			return(NUL);	/* return data			*/
		}


		if(c1 == DLE){			/* Transparent Mode  	*/

			BLEN--;			/* Keine Checkbyte	*/
			if(PROT)	fprintf(flink,"\n<DLE>");
			readbyte(&c1);
			CRC_BUF[BLEN++]=c1;

			if(c1 == ENQ)		btx_TRD=ON;
			if(c1 == DLE)		return(NUL);
		}	
	
		lc1 = c1;			/* merke last prot	*/
		if(c1 == ITB){			/* protokoll btx ITB 	*/
				if(PROT) fprintf(flink,"<ITB>");
				if(PROT) fprintf(flink,"<ACK>");
				if( readbcc() ){
					if(PROT)   fprintf(flink,"<ITB-NAK>");
					send_prot(NAK);	
					return(ON);
				}
				send_prot(ACK);
				btx_X_NAK = btx_X;
				btx_Y_NAK = btx_Y;
				return(ON);
		}


		if(c1 == ETB){		/* Zusammenhaengender Block */
				if(PROT) fprintf(flink,"<ETB>");
				if(PROT) fprintf(flink,"<ACK-%c>\n",ACKx);
				if( readbcc() ){
					if(PROT) fprintf(flink,"<ETB-NAK>");
					send_prot(NAK);
					return(ON);
				}
				send_prot(DLE);
				send_prot(ACKx);
				if(ACKx=='1'){
					ACKx = ACK0;
				}else{
					ACKx = ACK1;
				}	
				btx_X_NAK = btx_X;
				btx_Y_NAK = btx_Y;
				return(ON);
		}

		if(c1 == ETX){		/* Zusammenh. Block end */
				if(PROT) fprintf(flink,"<ETX>");
				if(PROT) fprintf(flink,"<ACK-%c>\n",ACKx);
				if( readbcc() ){
					if(PROT) fprintf(flink,"<ETX-NAK>\n");
					send_prot(NAK);
					return(ON);
				}
				send_prot(DLE);
				send_prot(ACKx);
				if(ACKx=='1'){
					ACKx=ACK0;
				}else{
					ACKx=ACK1;
				}
				btx_X_NAK = btx_X;
				btx_Y_NAK = btx_Y;
				return(ON);
		}
		if(c1 == ENQ){		/* Block abort forwart */
			if(btx_TRD){
				if(PROT) 	fprintf(flink,"<ENQ>");
				if(PROT)	fprintf(flink,"<TRD>");
				ACKx=ACK0;	/* init ACK=0	*/
				sprintf(TWFILE, "TRD%02d.trd", btx_TSW_dn++);
				if(((char *)logtw=(char *)fopen(TWFILE,"w"))==
				    (char *)NULL){
					if(DEBUG) fprintf(flink,"<OPEN-TRD>"); 
					btx_locate(23,10);
					addstr("Can't open Transparent File");
					btx_locate(btx_X,btx_Y);
				}
				btx_locate( 0,45 );
				addstr("Transparente Daten Uebertragung");
				btx_locate( 1,45 );
				addstr( TWFILE );
				btx_locate(btx_X, btx_Y);

				send_prot(DLE);
				send_prot(ACKx);
				if(PROT) fprintf(flink,"<ACK-%c>\n",ACKx);
				if(ACKx=='1')
					ACKx=ACK0;
				else
					ACKx=ACK1;

			}else{
				send_prot(NAK);
				if(PROT)	fprintf(flink,"<ENQ>");
				if(PROT)	fprintf(flink,"<NAK send>");
				btx_X = btx_X_NAK;
				btx_Y = btx_Y_NAK;
				btx_locate(btx_X, btx_Y);

				return(ON);
			}
			return(ON);
		}
		/* -------------------------------------------- */
		/*	Terminal Facility Identifier		*/
		/*	siehe Haeder btx.h parameter SPTFI	*/
		/* -------------------------------------------- */

		if((c1 == EOT) && (btx_TFI)){
				if(PROT)	fprintf(flink,"<SEND TFI>");
				send_prot(SOH);
				send_prot(US);
				send_prot(TFI);
				send_prot(AM1);
				send_prot(GP9);
				send_prot(SPID);	
				send_prot(SPTFI);
				send_prot(ETX);
				btx_TFI=OFF;
				ACKx=ACK1;
				return(ON);
		}		
		if(c1 == EOT){		/* End of Transmission */
				if(PROT)	fprintf(flink,"<EOT>\n");
				ACKx=ACK1;
				btx_X_NAK = btx_X;
				btx_Y_NAK = btx_Y;
				return(ON);
		}
		
		if(c1 == SOH){		/* Start of Head	*/
				if(PROT)	fprintf(flink,"<SOH>");
				return(ON);
		}
		if(c1 == STX){		/* Start of Text	*/
				if(PROT)	fprintf(flink,"<STX>");
				BLEN=0;
				btx_X_NAK = btx_X;
				btx_Y_NAK = btx_Y;
				return(ON);
		}
		if(c1 == NUL){		/* Filler Byte		*/
				return(ON);
		}
		if(c1 == SYN){		/* Not used for CEPT */
				if(PROT)	fprintf(flink,"<SYN>");
				return(ON);
		}

	}
return(con);
}

int	readbcc()
{
unsigned char	bcc1,bcc2;
unsigned short  crc; 
unsigned char	crc_1, crc_2;
unsigned short  calc_crc16();
int 	temp1;
static	int	crc_xx, crc_yy;
static	int	btx_NAK_count;

	crc=0;
	readbyte(&temp1);
	bcc2 = (unsigned char) temp1;
	readbyte(&temp1);
	bcc1 = (unsigned char) temp1;
	
	crc = calc_crc16( CRC_BUF, BLEN );
	crc_1 = crc >> 8;
	crc_2 = crc;

	if((bcc1 != crc_1) || (bcc2 != crc_2)){

	    btx_NAK_count++;
	    if(PROT) fprintf(flink,"<BCC[%x][%x]>", bcc1,bcc2);
            if(PROT) fprintf(flink,"<CRC[%x][%x]len[%d]>",crc_1,crc_2,BLEN);
	    if(PROT) fprintf(flink,"<NAK[%d]>", btx_NAK_count);

	    BLEN=NUL;
	    CRC_BUF[0]='\0';
	    btx_locate( crc_xx, crc_yy );	/* go old position	 */
	    
	    if((btx_NAK_count > MAX_NAK)){
			fprintf(stderr, "Zuviele Uebertragungsfehler [%d]\n",
					btx_NAK_count);
			i_exit( -1 );
	    }

    	return(-1);		/* CRC-Error Checksum	make NAK  */
	}
	CRC_BUF[0]='\0';	
	BLEN=NUL;
	btx_NAK_count=0;		/* block ok, set NAK-count init	    */
	crc_xx=btx_X; 	crc_yy=btx_Y;	/* letzte Position sichern, falls   */
					/* naechster Block einen Fehler hat */
return( 0 );
}
