/*
 * Display the help screen.  Press any key to continue.  If the ascii_hot
 * string is more than 4 characters wide, this screen will look silly.
 * Maybe one day, this will also contain page-full descriptions of each
 * command.
 */

#include <stdio.h>
#include <curses.h>
#include "config.h"
#include "misc.h"

void
help_screen(hot)
char *hot;
{
	extern int fd;
	WINDOW *h_win, *newwin();

	h_win = newwin(17, 80, 0, 0);

	if(!LANGUAGE){
	mvwattrstr(h_win, 1, 28, A_BOLD, "P C O M M       H E L P\n");
	horizontal(h_win, 2, 1, 78);
	mvwattrstr(h_win, 4, 2, A_BOLD, "Major Functions           Utility Functions        File Functions           \n\n");
	mvwprintw(h_win,  6,  2, "Dialing Directory.%4.4s-D  Program Info ....%4.4s-I  Send Files ....%4.4s-<up>", hot, hot, hot);
	mvwprintw(h_win,  7,  2, "Auto Redial ......%4.4s-R  Setup Screen ....%4.4s-S  Receive Files .%4.4s-<down>", hot, hot, hot);
	mvwprintw(h_win,  8,  2, "Keyboard Macros ..%4.4s-M  Change Directory.%4.4s-B  Pass Thru Mode.%4.4s-T", hot, hot, hot);
	mvwprintw(h_win,  9,  2, "Line Settings ....%4.4s-P  Clear Screen ....%4.4s-C  Directory .....%4.4s-F", hot, hot, hot);
	mvwprintw(h_win, 10,  2, "Exit Pcomm .......%4.4s-X  Toggle Duplex ...%4.4s-E  Screen Dump ...%4.4s-G", hot, hot, hot);
	mvwprintw(h_win, 11,  2, "Unix Gateway .....%4.4s-4  Hang Up Phone ...%4.4s-H  Start Data Log.%4.4s-1", hot, hot, hot);
	mvwprintw(h_win, 12,  2, "Call Log-Account..%4.4s-<  Printer On/Off ..%4.4s-L  Toggle Log ....%4.4s-2", hot, hot, hot);
	mvwprintw(h_win, 13,  2, "System Parameter..%4.4s->  Toggle CR-CR/LF .%4.4s-3", hot, hot);
	mvwprintw(h_win, 14,  2, "Modem Reset ......%4.4s-Z  Break Key .......%4.4s-7", hot,hot);
	box(h_win, VERT, HORZ);
	mvwaddstr(h_win, 16, 26, " Press any key to continue ");
	}else{
	mvwattrstr(h_win, 1, 26, A_BOLD, "P C O M M    H I L F S M E N \n");
	horizontal(h_win, 2, 1, 78);
	mvwattrstr(h_win, 4, 2, A_BOLD, "Haupt Funktionen          Hilfs Funktionen         Datei Funktionen        \n\n");
	mvwprintw(h_win,  6,  2, "Whlverzeichnis ..%4.4s-D  Programm Info ...%4.4s-I  Sende Datei ...%4.4s-U", hot, hot, hot);
	mvwprintw(h_win,  7,  2, "Wahlwiederholung .%4.4s-R  Konfigurieren....%4.4s-S  Empfange Datei.%4.4s-N", hot, hot, hot);
	mvwprintw(h_win,  8,  2, "Tastatur Makros ..%4.4s-M  Verzeichnis .....%4.4s-B  Timeout Zeit...%4.4s-T", hot, hot, hot);
	mvwprintw(h_win,  9,  2, "Leitungsparameter.%4.4s-P  Bild lschen ....%4.4s-C  Verzeichnis ...%4.4s-F", hot, hot, hot);
	mvwprintw(h_win, 10,  2, "Pcomm beenden ....%4.4s-X  Tausche Duplex ..%4.4s-E  Hardcopy  .....%4.4s-G", hot, hot, hot);
	mvwprintw(h_win, 11,  2, "Unix Gateway .....%4.4s-4  Modem auflegen ..%4.4s-H  Start Logdatei.%4.4s-1", hot, hot, hot);
	mvwprintw(h_win, 12,  2, "Logdatei Anrufe...%4.4s-<  Drucker Ein/Aus..%4.4s-L  Log Ein/Aus ...%4.4s-2", hot, hot, hot);
	mvwprintw(h_win, 13,  2, "System Parameter..%4.4s->  Tausche CR-CR/LF %4.4s-3", hot, hot);
	mvwprintw(h_win, 14,  2, "Modem Reset ......%4.4s-Z  Break Sequenz ...%4.4s-7", hot,hot);
	box(h_win, VERT, HORZ);
	mvwaddstr(h_win, 16, 24, " Drcke eine Taste um fortzufahren ");
	}
	wmove(h_win, 16, 79);
	wrefresh(h_win);

	wgetch(h_win);
	if (fd == -1) {
		werase(h_win);
		wrefresh(h_win);
	}
	delwin(h_win);
	return;
}
