/*
 * Display the terminal setup, query for changes.  A return code of 1
 * means something was changed, 2 means we have to kill and restart
 * the input routine.
 */

#include <stdio.h>
#include <curses.h>
#include "config.h"
#include "misc.h"
#include "param.h"
#include "status.h"

int
btx_setup()
{
	WINDOW *t_win, *newwin();
	int i, num, ret_code;
	char *ans, *strdup(), *str_prompt(), *menu_prompt();
	void free_ptr(), input_off(), line_set();
	static char *emu[3] = {"IBM-SET", "BLOCK  ", "NONE   "};
	char	*text, *hinw;

	t_win = newwin(23, 80, 0, 0);


if(!LANGUAGE){
horizontal(t_win, 0, 0, 32);
mvwattrstr(t_win, 0, 33, A_BOLD, "BTX-Mode Setup");
horizontal(t_win, 0, 48, 32);
mvwprintw(t_win, 4, 22, "1. Grafik-Typ  ............ %s", emu[param->btx]);
mvwprintw(t_win, 5, 22, "2. User ID ................ %s", param->btx_id);
mvwprintw(t_win, 6, 22, "3. Sub user number ........ %s", param->btx_mn);	
mvwprintw(t_win, 7, 22, "4. Password ............... %s", param->btx_pw);
horizontal(t_win, 19, 0, 80);
mvwattrstr(t_win, 20, 0, A_BOLD, "OPTION ==> ");
mvwaddstr(t_win, 20, 58, "Press <ESC> to return");
}else{
horizontal(t_win, 0, 0, 27);
mvwattrstr(t_win, 0, 28, A_BOLD, "BTX-Modus Konfiguration");
horizontal(t_win, 0, 52, 28);
mvwprintw(t_win, 4, 22, "1. Grafik-Typ  ............ %s", emu[param->btx]);
mvwprintw(t_win, 5, 22, "2. Benutzer ID ............ %s", param->btx_id);
mvwprintw(t_win, 6, 22, "3. Mitbenutzer Nummer ..... %s", param->btx_mn);	
mvwprintw(t_win, 7, 22, "4. Passwort ............... %s", param->btx_pw);
horizontal(t_win, 19, 0, 80);
mvwattrstr(t_win, 20, 0, A_BOLD, "AUSWAHL==> ");
mvwaddstr(t_win, 20, 55, "Drcke <ESC> fr Abbruch");
}
wmove(t_win, 20, 12);
touchwin(t_win);
wrefresh(t_win);
ret_code = 0;
while ((i = get_num(t_win, 1)) != -1) {
	switch (i) {
		case 1:
			if(!LANGUAGE){
				text="Grafik-type (1)Ibm (2)Block (3)None";
				hinw="Input numeric";
			}else{
				text="Grafik-Type (1)Ibm (2)Block (3)Keine";
				hinw="Eingabe nummerisch";
			}
			if ((num = num_prompt(t_win,22,30,text,hinw)) != -1){
				if((num < 1) || (num > 3)){
					num=1;
					beep();
				}else{
					mvwprintw(t_win, 4,50,"%s",emu[num-1]);
				}
				param->btx = num-1;
				ret_code = 1;
			}
			break;
		case 2:
			if(!LANGUAGE){
				text="User ID";
				hinw="Input alphanumeric";
			}else{
				text="Benutzer Kennung";
				hinw="Eingabe alphanummerisch";
			}
			if((ans = str_prompt(t_win,22,30,text,hinw)) != (char *)NULL){
				free_ptr(param->btx_id);
				param->btx_id=strdup(ans);
				mvwprintw(t_win, 5,50,"%s",param->btx_id);
				ret_code++;
			}
			break;
		case 3:
			if(!LANGUAGE){
				text="Sub-User number";
				hinw="Input numeric";
			}else{
				text="Mitbenutzer Nummer";
				hinw="Eingabe nummerisch";
			}
			if((ans = str_prompt(t_win,22,30,text,hinw)) != (char *)NULL){
				free_ptr(param->btx_mn);
				param->btx_mn=strdup(ans);
				mvwprintw(t_win, 6,50,"%s",param->btx_mn);
				ret_code++;
			}
			break;
		case 4:
			if(!LANGUAGE){
				text="Password";
				hinw="Input alphanumeric";
			}else{
				text="Passwort";
				hinw="Eingabe alphanummerisch";
			}
			if((ans = str_prompt(t_win,22,30,text,hinw)) != (char *)NULL){
				free_ptr(param->btx_pw);
				param->btx_pw=strdup(ans);
				mvwprintw(t_win, 7,50,"%s",param->btx_pw);
				ret_code++;
			}
			break;
		default:
			beep();
		}
		mvwaddch(t_win, 20, 12, (chtype) ' ');
		clear_line(t_win, 21, 0, 0);
		clear_line(t_win, 22, 0, 0);
		wmove(t_win, 20, 12);
		wrefresh(t_win);
	}
	delwin(t_win);
	return(ret_code);
}
