/*
 * Display the terminal setup, query for changes.  A return code of 1
 * means something was changed, 2 means we have to kill and restart
 * the input routine.
 */

#include <stdio.h>
#include <curses.h>
#include "config.h"
#include "misc.h"
#include "param.h"
#include "status.h"

int
emu_setup()
{
	WINDOW *t_win, *newwin();
	int i, num, ret_code;
	char *ans, *strdup(), *str_prompt(), *menu_prompt();
	void free_ptr(), input_off(), line_set();
	static char *emu[3] = {"IBM-SET", "BLOCK ", "NONE  "};

	t_win = newwin(23, 80, 0, 0);

	horizontal(t_win, 0, 0, 32);
	mvwattrstr(t_win, 0, 33, A_BOLD, "BTX-Terminal Setup");
	horizontal(t_win, 0, 48, 32);
	mvwprintw(t_win, 4, 22, "1. Grafik-Typ  ...... %s", emu[param->btx]);
    	mvwaddstr(t_win, 6, 22, "");	
	horizontal(t_win, 19, 0, 80);
	mvwattrstr(t_win, 20, 0, A_BOLD, "OPTION ==> ");
	mvwaddstr(t_win, 20, 58, "Press <ESC> to return");
	wmove(t_win, 20, 12);
	touchwin(t_win);
	wrefresh(t_win);
	ret_code = 0;
	while ((i = get_num(t_win, 1)) != -1) {
		switch (i) {
			case 1:
				if ((num = num_prompt(t_win,22, 30, "Emualtion", "decimal code for the Type")) != -1) {
					if((num < 1) || (num > 3)){
						beep();
					}else{
	mvwprintw(t_win, 4, 22, "Emulation        ...... %s", emu[num-1]);
					}
					param->btx = num-1;
					ret_code = 1;
				}
				break;
			default:
				beep();
		}
		mvwaddch(t_win, 20, 12, (chtype) ' ');
		clear_line(t_win, 21, 0, 0);
		clear_line(t_win, 22, 0, 0);
		wmove(t_win, 20, 12);
		wrefresh(t_win);
	}
	delwin(t_win);
	return(ret_code);
}
