/*
 * Spawn a shell with the stdin and stdout swapped with the remote
 * system.  An undocumented feature:  The external protocol gateway
 * can be used to pipe the output of a normal Unix command to the
 * remote system.
 */

#include <stdio.h>
#include <signal.h>
#include <curses.h>
#include <fcntl.h>
#include <errno.h>
#include "config.h"

void
extrnl(cmd)
char *cmd;
{
	extern int fd, errno;
	WINDOW *xt_win, *newwin();
	int (*istat)(), (*qstat)(), epid;
	char *shell, *shellpath, *getenv(), *strrchr(), buf[40], *ttyname();
	char *strcpy();
	unsigned int sleep();
	void _exit(), input_off();

	input_off();
					/* a full window */
	xt_win = newwin(LINES, COLS, 0, 0);
	touchwin(xt_win);
	wrefresh(xt_win);
					/* out of curses mode */
	resetterm();

	shellpath = getenv("SHELL");
	if (shellpath == (char *)NULL || *shellpath == '\0')
		shellpath = "/bin/sh";

	shell = strrchr(shellpath, '/') + 1;

	if (!(epid = fork())) {
		setpgrp();
						/* recreate the device name */
		strcpy(buf, ttyname(fd));
		close(fd);
						/* swap the stdin */
		close(0);
#ifdef UNIXPC
		if (!strncmp(buf, "/dev/ph", 7))
			open(buf, O_RDWR);
		else
#endif /* UNIXPC */
		open(buf, O_RDONLY);
						/* swap the stdout */
		close(1);
#ifdef UNIXPC
		if (!strncmp(buf, "/dev/ph", 7))
			open(buf, O_RDWR);
		else
#endif /* UNIXPC */
		open(buf, O_WRONLY);
#ifdef SETUGID
		setgid(getgid());
		setuid(getuid());
#endif /* SETUGID */
		execl(shellpath, shell, "-c", cmd, (char *) 0);
		_exit(1);
	}
	istat = signal(SIGINT, SIG_IGN);
	qstat = signal(SIGQUIT, SIG_IGN);

	/*
	 * Check the keyboard while the external program is running.  If
	 * the user hits the <ESC> key, then kill the entire process 
	 * group associated with the new shell.
	 */
	while(1) {
		switch(wait_key(stdscr, 1)) {
			case -1:	/* timed out */
				break;
			case 27:	/* a user abort */
				kill(-epid, SIGKILL);
				break;
			default:
				beep();
				break;
		}
					/* see if the process is still active */
		if ((kill(epid, 0) == -1) && errno == ESRCH)
			break;
	}

	signal(SIGINT, istat);
	signal(SIGQUIT, qstat);
					/* back to curses mode */
	sleep(1);
	fixterm();

	clearok(curscr, TRUE);
	werase(xt_win);
	wrefresh(xt_win);
	delwin(xt_win);
	return;
}
